modified client
[xfstests-dev.git] / 041
1 #! /bin/sh
2 # FS QA Test No. 041
3 #
4 # growfs QA tests - repeatedly fill/grow the filesystem
5 # check the filesystem contents after each operation
6 #
7 #-----------------------------------------------------------------------
8 # Copyright (c) 2000-2002 Silicon Graphics, Inc.  All Rights Reserved.
9 #-----------------------------------------------------------------------
10 #
11 set +x
12 # creator
13 owner=ajag@sgi.com
14
15 seq=`basename $0`
16 echo "QA output created by $seq"
17
18 here=`pwd`
19 tmp=/tmp/$$
20 status=1        # failure is the default!
21
22 _cleanup()
23 {
24     cd /
25     umount $SCRATCH_MNT
26     rm -f $tmp.*
27 }
28 trap "_cleanup ; exit \$status" 0 1 2 3 15
29
30 # get standard environment, filters and checks
31 . ./common.rc
32 . ./common.filter
33
34 # real QA test starts here
35 _supported_fs xfs
36 _supported_os IRIX Linux
37
38 _require_scratch
39 _require_nobigloopfs
40 umount $SCRATCH_DEV 2>/dev/null
41
42 _fill()
43 {
44     if [ $# -ne 1 ]; then echo "Usage: _fill \"path\"" 1>&2 ; exit 1; fi
45     _do "Fill filesystem" \
46         "src/fill2fs --verbose --dir=$1 --seed=0 --filesize=65536 --stddev=32768 --list=- >>$tmp.manifest"
47 }
48
49 _do_die_on_error=message_only
50 rm -f $seq.full
51 agsize=32
52 echo -n "Make $agsize megabyte filesystem on SCRATCH_DEV and mount... "
53 _do "_scratch_mkfs_xfs -dsize=${agsize}m,agcount=1"
54 [ $? -ne 0 ] && exit
55 _do "_scratch_mount"
56 [ $? -ne 0 ] && exit
57 echo "done"
58
59 # full allocation group -> partial; partial -> expand partial + new partial;
60 # partial -> expand partial; partial -> full
61 # 17 -> 33 -> 35 -> 48 megabytes, converted to fs blocks below
62 # for size in 4352 8448 8960 12288
63 # 33 -> 67 -> 75 -> 96 converted to fs blocks:
64 for size in 8448 17512 19200 24576
65 do
66     _fill $SCRATCH_MNT/fill_$size
67     _do "Grow filesystem to $size blocks" "xfs_growfs -D ${size} $SCRATCH_MNT"
68     echo -n "Flush filesystem... "
69     _do "umount $SCRATCH_MNT"
70     _do "_scratch_mount"
71     echo "done"
72     echo -n "Check files... "
73     if ! _do "src/fill2fs_check $tmp.manifest"; then
74       echo "fail (see $seq.full)"
75       _do "cat $tmp.manifest"
76       _do "ls -altrR $SCRATCH_MNT"
77       _do "dd if=$SCRATCH_DEV bs=4096 count=$size | gzip -9 > $seq.fsimage.gz"
78       status=1 ; exit
79     fi
80     echo "done"
81 done
82
83 # success, all done
84 echo "Growfs tests passed."
85 status=0 ; exit